package com.fjhx.jushuitan.service.shop.impl;

import cn.hutool.core.bean.BeanUtil;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.fjhx.jushuitan.entity.shop.dto.ShopInfoDto;
import com.fjhx.jushuitan.entity.shop.dto.ShopInfoSelectDto;
import com.fjhx.jushuitan.entity.shop.po.ShopInfo;
import com.fjhx.jushuitan.entity.shop.vo.ShopInfoVo;
import com.fjhx.jushuitan.mapper.shop.ShopInfoMapper;
import com.fjhx.jushuitan.service.shop.ShopInfoService;
import com.ruoyi.common.utils.wrapper.IWrapper;
import com.ruoyi.common.utils.wrapper.SqlField;
import org.springframework.stereotype.Service;


/**
 * <p>
 * 店铺管理 服务实现类
 * </p>
 *
 * @author
 * @since 2024-01-07
 */
@Service
public class ShopInfoServiceImpl extends ServiceImpl<ShopInfoMapper, ShopInfo> implements ShopInfoService {

    @Override
    public Page<ShopInfoVo> getPage(ShopInfoSelectDto dto) {
        IWrapper<ShopInfo> wrapper = getWrapper();

        //关键字检索
        wrapper.keyword(dto.getKeyword(),
                new SqlField(ShopInfo::getCode),
                new SqlField(ShopInfo::getCode),
                new SqlField("de", ShopInfoVo::getDeptName)
        );

        wrapper.orderByDesc("si", ShopInfo::getId);
        Page<ShopInfoVo> page = this.baseMapper.getPage(dto.getPage(), wrapper);
        return page;
    }

    @Override
    public ShopInfoVo detail(Long id) {
        ShopInfo ShopInfo = this.getById(id);
        ShopInfoVo result = BeanUtil.toBean(ShopInfo, ShopInfoVo.class);
        return result;
    }

    @Override
    public void add(ShopInfoDto shopInfoDto) {
        this.save(shopInfoDto);
    }

    @Override
    public void edit(ShopInfoDto shopInfoDto) {
        this.updateById(shopInfoDto);
    }

    @Override
    public void delete(Long id) {
        this.removeById(id);
    }

}
